Subject: RE: M3UA v9: Receipt of Primitive from the M3UA-User (also SUA v8 )

From: [email-masked]
Date: Thu, 18 Oct 2001 00:08:31 +0300

Hi Brian,

> The way that the SCTP sockets draft has gone, it is possible 
> to "peel-off" a stream as a separate socket interface.  Similar 
> approaches are possible in STREAMS and others.  The thing sitting 
> at the end of stream '0' may be fully incapable of processing DATA 
> or SNMM messages and only capable of processing ASPTM/SM.  The 
> process sitting at the end of the stream '0' may have much greater 
> priviledges than one sitting at the end of another stream.

I think it good to remember that the SCTP sockets draft is an API,
and that API is an implementation dependent issue.  
 
> Could we maybe approach this from a different direction an say that:
> 
> 	An SGP or ASP MAY discard DATA or SNMM messages received on
> 	stream '0'.  Therefore, an SGP or ASP SHOULD NOT send DATA or
> 	SNMM messages on stream '0'.
> 
> As long as it is clearly state that an implementation is permitted to
> ignore DATA and SNMM that arrive erroneously on stream '0', that would
> resolve the issue.

I'm not completely comfortable with all of the implications of this - 
let me think about it for some time.  Specifically, if an implementation
MAY discard data (silently, I suppose), what do we do, in a 
single stream case? Potentially, this could be an interworking problem.

Perhaps we should say something that:

	If an SGP or ASP does not support recieving and DATA or SNMM
messages on
	stream '0', then it MUST discard the messages and MUST send and
Error
	Message with the Error Code "Invalid Stream Identifier."  An SGP or
	ASP recieving such a message MUST send the message on a sream other
	than '0.'

John

---
You are currently subscribed to sigtran as: [email-masked]
To unsubscribe send a blank email to [email-masked]

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Wed, 17 Oct 2001 17:37:51 -0500

John,

John Loughney wrote:                                         (Thu, 18 Oct 2001 00:08:31)
> and that API is an implementation dependent issue.  

The API is implemetnation dependent but the M3UA draft should not
restrict full use of a feature of the socket draft by not placing
a requirement here.

> 	ASP recieving such a message MUST send the message on a sream other

Perhaps my wording is no so good:

	Just say that if there are multiple streams,
	the sender MUST NOT send DATA or SNMM on
	stream '0'.

What's the matter with that?  Both sides are fully aware of how many
inbound and outbound streams there are.

ERR ("Unexpected Message") might be a better response.

> 
> John
> 
> 
> ---
> You are currently subscribed to sigtran as: [email-masked]

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/

---